﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Xml;
using System.IO;

namespace NAVConnector
{
    public class Provider
    {
        private TcpClient _tcpClient;
        private String _hostName;
        private int _portNumber;

        public Provider()
        { 
            _hostName = "localhost";
            _portNumber = 7777;
        }

        public Provider(string host, int port)
        {
            _hostName = host;
            _portNumber = port;
        }

        public bool TestConnection()
        {
            try
            {
                _tcpClient = new TcpClient(_hostName, _portNumber);
                return true;
            }
            catch
            {
                return false;
            }
        }

        private bool Send(String inMsg, out String outMsg)
        {
            try
            {
                _tcpClient = new TcpClient(_hostName, _portNumber);
                NetworkStream ns = _tcpClient.GetStream();
                byte[] buf1 = Encoding.Default.GetBytes(inMsg);                
                ns.Write(buf1, 0, buf1.Length);
                byte[] buf2 = new byte[_tcpClient.ReceiveBufferSize];
                int BytesRead;
                outMsg = String.Empty;
                do
                {
                    BytesRead = ns.Read(buf2, 0, _tcpClient.ReceiveBufferSize);
                    outMsg += Encoding.ASCII.GetString(buf2, 0, BytesRead);
                } while (BytesRead != 0);
                _tcpClient.Close();
                return true;
            }
            catch
            {
                outMsg = String.Empty;
                return false;
            }
        }



        public bool SendCommand(Dictionary<string, string> args, out String resultXml)
        {

            MemoryStream ms = new MemoryStream();
            XmlWriter xmlWriterMsg = new XmlTextWriter(ms, Encoding.Default);
            xmlWriterMsg.WriteStartDocument();
            xmlWriterMsg.WriteStartElement("command");
            foreach (KeyValuePair<string, string> arg in args)
            {                
                xmlWriterMsg.WriteElementString(arg.Key, arg.Value);            
            }            
            xmlWriterMsg.WriteEndElement();                                                
            xmlWriterMsg.WriteEndDocument();
            xmlWriterMsg.Flush();
            ms.Position = 0;
            StreamReader sr = new StreamReader(ms);
            string strOutput = sr.ReadToEnd();
            bool SendResult = Send(strOutput, out resultXml);
            return SendResult;
        }


    }

}
